﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;

namespace Erettsegi27_Nézőtér
{
    class Szék
    {
        public int Sor { get; private set; }
        public int SzékSzáma { get; private set; }
        public bool Foglalt { get; private set; }
        public int Kategória { get; private set; }
        public bool Szingli { get; private set; }

        public Szék(int s, int sz, char f, char k, bool bal_foglalt, bool jobb_foglalt)
        {
            Sor = s;
            SzékSzáma = sz;
            Foglalt = f == 'x';
            Kategória = int.Parse(k.ToString());
            Szingli = !Foglalt && bal_foglalt && jobb_foglalt;
        }

        public int Ár { get { return Kategória == 5 ? 1500 : 6000 - 1000 * Kategória; } }

        public string Szabad { get { return Foglalt ? "x" : Kategória.ToString(); } }

    }

    class Nezoter
    {
        static void Main()
        {
            Console.WriteLine("1. feladat: Adatszerkezet kialakítása, adatok beolvasása");
            List<Szék> székek = new List<Szék>();
            string[] forrásF = File.ReadAllLines("foglaltsag.txt");
            string[] forrásK = File.ReadAllLines("kategoria.txt");
            for (int s = 0; s < forrásF.Length; s++) //sorok
                for (int sz = 0; sz < forrásF[s].Length; sz++) //székek
                {
                    bool bal_foglalt, jobb_foglalt;
                    if (sz == 0) bal_foglalt = true; else bal_foglalt = forrásF[s][sz - 1] == 'x';
                    if (sz == forrásF[s].Length - 1) jobb_foglalt = true; else jobb_foglalt = forrásF[s][sz + 1] == 'x';
                    székek.Add(new Szék(s + 1, sz + 1, forrásF[s][sz], forrásK[s][sz], bal_foglalt, jobb_foglalt));
                }

            Console.Write("2. feladat: Kérem a sor és a szék számát szóközzel elválasztva = ");
            string[] inp = Console.ReadLine().Split();
            Console.WriteLine(székek.Where(x => x.Sor == int.Parse(inp[0]) && x.SzékSzáma == int.Parse(inp[1])).First().Foglalt ? "Foglalt" : "Szabad");

            Console.WriteLine("3. feladat: Az előadásra eddíg {0} jegyet adtak el, ez a nézőtér {1:P0}-a.", székek.Count(x => x.Foglalt), székek.Count(x => x.Foglalt) / (double)székek.Count);

            Console.WriteLine("4. feladat: A legtöbb jegyet a(z) {0}. árkategóriában értékesítették.", székek.GroupBy(g => g.Kategória).OrderByDescending(x => x.Count()).First().Key);

            Console.WriteLine("5. feladat: A színház bevétele: {0} Ft", székek.Where(x => x.Foglalt).Sum(x => x.Ár));

            Console.WriteLine("6. feladat: Egyedülálló helyek száma {0} db", székek.Count(x => x.Szingli));

            Console.WriteLine("7. feladat: szabad.txt");
            File.WriteAllLines("szabad.txt", székek.GroupBy(g => g.Sor).Select(g => g.Aggregate("", (c, n) => c + n.Szabad)));

            Console.ReadKey();
        }
    }
}